/* myCalSettings */

#import <Cocoa/Cocoa.h>


@interface myCalSettings : NSObject
{
	NSMutableDictionary *bdays;
	NSMutableDictionary	*specialDayDict;
	NSError *err;
	NSString *sImagePath;		// Path to the image to load.
	
	BOOL bgImageIsURL;		// TRUE if http or https
	BOOL ImagePathisDir;	// TRUE if a directory.
	
	NSImage *bgImage;			// Image to display in the current month.
	NSImage *bgThemeImage[19];	// 7 + 12 = 19
	
	int ImageStyle;			// set to 1 for Image under calendar, 2= above.
				 			// set to 2 for Image above calendar.
							//
	BOOL showMonth;			// Show month title.
	BOOL bSpecialDays;		// Set to TRue if enabled.
	int	textDS;				// set to 1 for drop shadow
	int showAddressBDays;	// set to 1 for drawing names in calandar.
	int ImageScaleType;		// set to 1 for fix aspect ration, set to 0 to scale to fit.
	int LastThemeLoaded;
	int startMonthOffset;	// 0 = start, -1, -2 etc.
	int DrawWindowTitle;
	int cntH, cntV;
	int ShowWeekNum;	// 0 = no, 1 = Yes.
	int firstDay;		// 0 = sunday, 1 = monday.
	int dayHPos;		// 0 - left, 1 = center, 2 = right
	int margin;			// 0 = no margin, > 0 inset image in frame.
	int marginC;			// 0 = no margin, > 0 inset month cal in frame.
	int iDrawFrame;		// V2.0b17 
	
	int HorGrid,VerGrid;		// flag for Draw or not drawing grids.
}
- (NSError *) err;	
- (void) setErr: (NSError *) err;	
- (NSMutableDictionary *) bdays;	// format ok keys is: month-day
- (void) setBdays: (NSMutableDictionary *) dayListDict;
- (NSMutableDictionary *) dictFromDateLabels;

- (void) setSImagePath: (NSString	*) aPath;
- (NSString *) sImagePath;
- (BOOL) imagePathisDir;

- (void) LoadMonthImage: (int) month;
- (void) LoadSingleImage: (NSString*)aPath;
- (BOOL) loadCALDesc: (	NSString *) imagePath;

- (NSError*) buildErrorWithDescription:(NSString*)description andReason:(NSString*)reason andSolution:(NSString*)recovery ;

- (void) SetGridLines: (int) hor Ver: (int) ver;

- (void) setIDrawFrame: (int) value;
- (int) iDrawFrame;
- (int) startMonthOffset;
- (void) setStartMonthOffset: (int) value;

- (void) SetMargin: (int) value;
- (void) SetMarginC: (int) value;
- (float) margin;
- (float) marginC;

- (void) SetDrawFrame: (int) value;
- (int) drawFrameValue;

- (void) SetShowWeekNum: (int) value;
- (int) showWeekNum;

- (void) SetFirstDayOfWeek: (int) value;
- (void) SetShowMonth: (int) value;

- (int) SetBirthday: (int) i;
- (int) SethPosDay: (int) i;
- (int) SetImageStyle: (int) i;
- (int) imageStyle;
- (int) SetImageScaleType: (int) i;
- (int) imageScaleType;

- (int) SetDropShadow: (int) i;
- (BOOL) SetSpecialDay: (BOOL) v;
- (int) SetOffsetMonth: (int) i;
- (int) SetCntV: (int) i;
- (int) SetCntH: (int) i;

- (int) cntV;
- (int) cntH;
- (int) VerGrid;
- (int) HorGrid;
- (int) firstDay;
- (int) showAddressBDays;
- (int) dayHPos;
- (int) textDS;
- (void) setTextDS: (int) value;

- (BOOL) bgImageIsURL;

- (void) freeImageCache;
- (void) LoadImage: (NSString*)aPath;
- (NSImage *) bgImage;

- (int) SetDrawWindowTitleFormat: (int) t;
- (int) drawWindowTitle;

- (NSMutableDictionary *) specialDayDict;

- (NSArray 	*) BirthDaySearchStart: (NSCalendarDate *) today;
- (NSMutableDictionary *) dictFromDateLabels;
- (NSMutableDictionary *) bdays;
- (void) setBdays: (NSMutableDictionary *) dayListDict;
- (NSString *) GetBirthDay: (NSCalendarDate *) today  ABRes: (NSArray *)ABresults;

@end
